## START: Set by rpmautospec
## (rpmautospec version 0.8.1)
## RPMAUTOSPEC: autorelease, autochangelog
%define autorelease(e:s:pb:n) %{?-p:0.}%{lua:
    release_number = 1;
    base_release_number = tonumber(rpm.expand("%{?-b*}%{!?-b:1}"));
    print(release_number + base_release_number - 1);
}%{?-e:.%{-e*}}%{?-s:.%{-s*}}%{!?-n:%{?dist}}
## END: Set by rpmautospec

%global vc_commit 9d255266e1df8f1dc5d11e1fbb03213acfaa4fc7
%global vc_shortcommit %(c=%{vc_commit}; echo ${c:0:7})

%global optflags %{optflags} -w

# not compatible with newer clang versions
%if 0%{?fedora} >= 38 || 0%{?rhel} >= 8
%global llvm_compat 15
%endif

Name: intel-igc
Version: 2.12.7
Release: %autorelease
Summary: Intel Graphics Compiler for OpenCL

License: MIT
URL: https://github.com/intel/intel-graphics-compiler
Source0: %{url}/archive/v%{version}/v%{version}.tar.gz
Source1: https://github.com/intel/vc-intrinsics/archive/%{vc_commit}/vc-intrinsics-%{vc_shortcommit}.tar.gz

# This is just for Intel GPUs
ExclusiveArch:  x86_64

BuildRequires: cmake
BuildRequires: make
BuildRequires: git
BuildRequires: gcc
BuildRequires: gcc-c++
BuildRequires: ninja-build
BuildRequires: llvm%{?llvm_compat}-devel
BuildRequires: lld%{?llvm_compat}-devel
BuildRequires: clang%{?llvm_compat}
BuildRequires: flex
BuildRequires: bison
BuildRequires: python3
BuildRequires: python3-mako
BuildRequires: python3-pyyaml
BuildRequires: zlib-devel
BuildRequires: intel-opencl-clang-devel
BuildRequires: libffi-devel
BuildRequires: libunwind-devel
%if %{?llvm_compat} == 15
BuildRequires: spirv-llvm15.0-translator-devel
BuildRequires: spirv-llvm15.0-translator-tools
%else
BuildRequires: spirv-llvm-translator%{?llvm_compat}-devel
BuildRequires: spirv-llvm-translator%{?llvm_compat}-tools
%endif
BuildRequires: spirv-headers-devel
BuildRequires: spirv-tools-devel

Requires:      %{name}-libs%{?_isa} = %{version}-%{release}

# Unfortunately, it isn't trivially posible to build with prebuilt vc-intrinsics
Provides: bundled(intel-vc-intrinsics)

%description
The Intel Graphics Compiler for OpenCL is an LLVM based compiler for OpenCL targeting Intel Gen graphics hardware architecture.

%package       devel
Summary:       Intel Graphics Compiler Frontend - Devel Files
Requires:      %{name}-libs%{?_isa} = %{version}-%{release}

%description   devel
Devel files for Intel Graphics Compiler for OpenCL.

%package       libs
Summary:       Intel Graphics Compiler Frontend - Library Files
Requires:      %{name} = %{version}-%{release}

%description   libs
Library files for Intel Graphics Compiler for OpenCL.

%prep
tar -xf %{SOURCE1}

%autosetup -n intel-graphics-compiler-%{version} -p1

%build
%cmake \
    -DCMAKE_BUILD_TYPE=Release \
    -DBUILD_SHARED_LIBS:BOOL=OFF \
    -DIGC_OPTION__LLVM_PREFERRED_VERSION='%(rpm -q --qf '%%{version}' llvm%{?llvm_compat}-devel | cut -d. -f1 | sed "s/$/.0.0/")' \
    -DVC_INTRINSICS_SRC="%{_builddir}/vc-intrinsics-%{vc_commit}" \
%ifarch x86_64
    -DIGC_OPTION__ARCHITECTURE_TARGET='Linux64' \
%endif
%ifarch i686
    -DIGC_OPTION__ARCHITECTURE_TARGET='Linux32' \
%endif
    -DIGC_OPTION__LINK_KHRONOS_SPIRV_TRANSLATOR=ON \
    -DIGC_BUILD__VC_ENABLED=ON \
    -DIGC_OPTION__SPIRV_TRANSLATOR_MODE=Prebuilds \
    -DIGC_OPTION__CLANG_MODE=Prebuilds \
    -DIGC_OPTION__LLD_MODE=Prebuilds \
    -DIGC_OPTION__LLVM_MODE=Prebuilds \
    -DLLVM_ROOT=%{_libdir}/llvm%{?llvm_compat}/ \
    -DIGC_OPTION__SPIRV_TOOLS_MODE=Prebuilds \
    -DIGC_OPTION__USE_PREINSTALLED_SPIRV_HEADERS=ON \
    -DIGC_OPTION__VC_INTRINSICS_MODE=Source \
    -DINSTALL_GENX_IR=ON \
    -Wno-dev \
    -G Ninja

%cmake_build

%install
%cmake_install

%files
%{_bindir}/iga{32,64}

%files libs
%license LICENSE.md
%license %{_libdir}/igc2/NOTICES.txt
%dir %{_libdir}/igc2/
%{_libdir}/libiga{32,64}.so.2.*
%{_libdir}/libigc.so.2.*+*
%{_libdir}/libigdfcl.so.2.*

%files devel
%{_libdir}/libiga{32,64}.so.2
%{_libdir}/libigc.so.2
%{_libdir}/libigdfcl.so.2
%{_includedir}/igc
%{_includedir}/iga
%{_includedir}/visa
%{_libdir}/pkgconfig/igc-opencl.pc

%changelog
## START: Generated by rpmautospec
* Mon Jul 07 2025 Androniychuk, Pavel <pavel.androniychuk@intel.com> - 2.12.7-1
- Update to v2.12.7

* Thu Jun 26 2025 František Zatloukal <fzatlouk@redhat.com> - 2.12.5-1
- intel-igc-2.12.5

* Mon Jun 23 2025 Androniychuk, Pavel <pavel.androniychuk@intel.com> - 2.11.10-1
- Update to v2.11.10

* Thu Feb 13 2025 František Zatloukal <fzatlouk@redhat.com> - 2.7.8-1
- intel-igc-2.7.8 (RHBZ#2314527 , RHBZ#2340651)

* Fri Jan 17 2025 Fedora Release Engineering <releng@fedoraproject.org> - 1.0.17791.18-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_42_Mass_Rebuild

* Tue Dec 03 2024 František Zatloukal <fzatlouk@redhat.com> - 1.0.17791.18-2
- Rebuild

* Tue Nov 26 2024 Ali Erdinc Koroglu <aekoroglu@linux.intel.com> - 1.0.17791.18-1
- Updated to 1.0.17791.18

* Tue Sep 24 2024 František Zatloukal <fzatlouk@redhat.com> - 1.0.17657.8-1
- intel-igc-1.0.17657.8 (RHBZ#2274079)

* Fri Aug 02 2024 František Zatloukal <fzatlouk@redhat.com> - 1.0.17224.11-1
- intel-igc-1.0.17224.11

* Thu Jul 18 2024 Fedora Release Engineering <releng@fedoraproject.org> - 1.0.16510.1-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_41_Mass_Rebuild

* Wed Apr 03 2024 František Zatloukal <fzatlouk@redhat.com> - 1.0.16510.1-1
- intel-igc-1.0.16510.1 (Fixes RHBZ#2272871)

* Wed Mar 27 2024 Frantisek Zatloukal <fzatlouk@redhat.com> - 1.0.16510.0-1
- intel-igc-1.0.16510.0

* Wed Jan 24 2024 Fedora Release Engineering <releng@fedoraproject.org> - 1.0.15313.1-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_40_Mass_Rebuild

* Sat Jan 20 2024 Fedora Release Engineering <releng@fedoraproject.org> - 1.0.15313.1-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_40_Mass_Rebuild

* Fri Oct 06 2023 Frantisek Zatloukal <fzatlouk@redhat.com> - 1.0.15313.1-1
- intel-igc-1.0.15313.1 (fixes RHBZ#2183055)
- Switch to llvm 17 compat package

* Thu Jul 20 2023 Fedora Release Engineering <releng@fedoraproject.org> - 1.0.13700.7-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_39_Mass_Rebuild

* Mon Mar 27 2023 Frantisek Zatloukal <fzatlouk@redhat.com> - 1.0.13700.7-1
- intel-igc-1.0.13700.7 (fixes RHBZ#2177378 )

* Mon Mar 06 2023 Frantisek Zatloukal <fzatlouk@redhat.com> - 1.0.13463.1-1
- intel-igc-1.0.13463.1 (fixes RHBZ#2175129 )

* Fri Feb 17 2023 Frantisek Zatloukal <fzatlouk@redhat.com> - 1.0.13230.4-1
- intel-igc-1.0.13230.4

* Thu Jan 19 2023 Fedora Release Engineering <releng@fedoraproject.org> - 1.0.12812.4-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_38_Mass_Rebuild

* Tue Nov 29 2022 Frantisek Zatloukal <fzatlouk@redhat.com> - 1.0.12812.4-1
- intel-igc-1.0.12812.4
- LLVM 15 Support (fixes RHBZ#2127746 )

* Mon Sep 19 2022 Pete Walter <pwalter@fedoraproject.org> - 1.0.12149-2
- Rebuild for llvm 15

* Fri Sep 16 2022 Frantisek Zatloukal <fzatlouk@redhat.com> - 1.0.12149.1-1
- intel-igc-1.0.12149.1

* Thu Sep 08 2022 Frantisek Zatloukal <fzatlouk@redhat.com> - 1.0.12149-1
- intel-igc-1.0.12149

* Tue Aug 30 2022 Frantisek Zatloukal <fzatlouk@redhat.com> - 1.0.12037.1-1
- intel-igc-1.0.12037.1

* Tue Aug 09 2022 Frantisek Zatloukal <fzatlouk@redhat.com> - 1.0.12037.1-1
- intel-igc-1.0.11702.1

* Thu Jul 21 2022 Fedora Release Engineering <releng@fedoraproject.org> - 1.0.11485-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_37_Mass_Rebuild

* Fri Jul 01 2022 Frantisek Zatloukal <fzatlouk@redhat.com> - 1.0.11485-1
- intel-igc-1.0.11485

* Sun May 29 2022 Frantisek Zatloukal <fzatlouk@redhat.com> - 1.0.11279-1
- intel-igc-1.0.11279
- add LLVM 13 and 14 patches

* Thu Mar 31 2022 Frantisek Zatloukal <fzatlouk@redhat.com> - 1.0.10778-1
- intel-igc-1.0.10778

* Sat Mar 19 2022 Frantisek Zatloukal <fzatlouk@redhat.com> - 1.0.10409-1
- intel-igc-1.0.10409
- use system spirv

* Thu Feb 24 2022 Frantisek Zatloukal <fzatlouk@redhat.com> - 1.0.10395-1
- intel-igc-1.0.10395

* Thu Feb 24 2022 Frantisek Zatloukal <fzatlouk@redhat.com> - 1.0.10395-1
- intel-igc-1.0.10395

* Fri Feb 18 2022 Frantisek Zatloukal <fzatlouk@redhat.com> - 1.0.10200-1
- intel-igc-1.0.10200

* Mon Dec 27 2021 Frantisek Zatloukal <fzatlouk@redhat.com> - 1.0.9933-1
- Initial package

## END: Generated by rpmautospec
